Allow non-unique names for projects
2008-02-11 15:22 - Robert Lemke

Status: Closed Start date: 2008-02-11
Priority: Normal Due date:

Assignee: % Done: 0%
Category: Projects Estimated time: 0.00 hour
Target version: 1.1.0

Resolution: Fixed

Description

Currently project names (I'm not referring to project keys) need to be unique. However, we have the situation at forge.typo3.org that
we need two projects of the same name but with different project keys.

Is there a technical reason why project names must be unique? | hacked the project name directly in the database and couldn't see
any bad effect yet.

Related issues:
Related to Redmine - Patch #32522: Add Project.find_by_name to target_project New
Has duplicate Redmine - Feature #6530: Allow multiple projects with same name Closed 2010-09-29

Associated revisions

Revision 4391 - 2010-11-11 14:39 - Jean-Philippe Lang

Allow non-unique names for projects (#630).

History

#1 - 2008-02-11 19:15 - Jean-Philippe Lang

AFAIK, there shouldn't be any side effect to have 2 projects with the same name.

This restriction was set at the very beginning to be able to identify a project by its name. | finally added the project identifier for that. I'll have a deeper
look at this before | remove this restriction.

#2 - 2009-02-13 13:01 - Nicklas Holm

Is this planned for any coming release, or will the current behaviour be kept for now?

#3 - 2009-02-15 14:04 - Ken Sands

just a positive nudge for this one, it'd be great to have the restriction lifted especially for subprojects within separate parents, | think a warning if that's
not the case that there is already a project with that name would be good but for subprojects it should just do a name check against other subprojects
in that set.

#4 - 2009-02-15 20:23 - Jeff Dombach

+1

#5 - 2009-02-18 23:38 - Thomas Pihl

You can test this yourself (with the usual disclaimers) by editing /app/models/project.rb

Find the line that say "validates_uniqueness_of :name, :identifier"

Remove ":name, " from that line

Save and test (i assume you run this on a copy of your environment). No warnings will be given if you use a previously used name.
T

#6 - 2009-02-19 21:51 - Ken Sands

Thanks, that seems to work great, now | just need to change the subprojects page heading to include the parent more clearly, I'm thinking make the
titte "PARENT PROJECT NAME > SUBPROJECT NAME" or something similar.
#7 - 2009-02-22 12:30 - Ken Sands

ok understand that | picked up ruby.... err yesterday, and have little idea currently how things are done but this modification in base.rhtml achieves
what | put in the above comment. | think the projects class should include a longname function which returns "[ParentName >>] [ParentName >>]....
ProjectName" this would return just the project name if it was a top level or the full path otherwise (that is when more than one level of subproject is
enabled) and | think would be handy to use in many situations.

<hl>
<% 1if (@project && !@project.new_record? %>
<% 1if @project.ancestors.any? %>
<%= @project.ancestors.collect {|p| link_to(h(p), :action => 'show',6 :id => p)}.Jjoin(" &#187; ") %> &gts&
gt
<% end %>
<% end %>

<%= h(@project && !@project.new_record? ? (@project.name : Setting.app_title) %>
</hl>

#8 - 2009-02-22 12:41 - Jean-Philippe Lang
You should have a look at #2788 and r2485.

#9 - 2009-02-22 13:49 - Ken Sands

Jean-Philippe Lang wrote:

You should have a look at #2788 and r2485.

That's brilliant, thanks.

#10 - 2009-03-18 09:21 - Nicklas Holm

Is this planned for any upcoming release?

#11 - 2010-02-11 18:59 - Lorenzo Pisani

what is the status on this? there is no reason for project names to be unique
this is especially annoying when 2 different projects need a subproject named for example 'Modules'

#12 - 2010-07-05 14:58 - Holger Just

The uniqueness of the project name is at least assumed in the RedmineReceivingEmails functionality.

#13 - 2010-07-05 16:04 - Felix Schéfer

Holger Just wrote:

The uniqueness of the project name is at least assumed in the RedmineReceivingEmails functionality.

As far as | can tell, the code disagrees on that, see source:trunk/app/models/mail_handler.rb#L 161, the project keyword is matched against the
identifier only.

I'd be in favor of dropping the uniqueness on project names too, this has become really cumbersome since the projects can be deeply nested.

#14 - 2010-07-05 16:24 - Felix Schafer

- Target version set to 1.1.0

Just had a look at where the project name might be of critical importance, and | only found the [[project:page]] wiki-link scheme for which either the
name or the identifier of the project are valid (see source:trunk/app/models/wiki.rb#L 67 and source:trunk/app/helpers/application_helper.rb#L 497
these are the two only "obvious" places, there might be other though).

This is a compatibility break, so | scheduled it for 1.1 (instead of 1.0.1), and it must be decided if we want to break this and if an upgrade path will be
provided, though honestly anyone using the project name instead of the identifier in wiki-links is at the mercy of a project name change, so I'd say
they're better off without it anyway :-)

#15 - 2010-07-28 21:56 - Andrew Sherman

+1

#16 - 2010-09-29 17:09 - lan DeFazio

+1
https://www.redmine.org/issues/2788
https://www.redmine.org/projects/redmine/repository/svn/revisions/2485
https://www.redmine.org/issues/2788
https://www.redmine.org/projects/redmine/repository/svn/revisions/2485
https://www.redmine.org/projects/redmine/wiki/RedmineReceivingEmails
https://www.redmine.org/projects/redmine/wiki/RedmineReceivingEmails
https://www.redmine.org/projects/redmine/repository/svn/entry/trunk/app/models/mail_handler.rb#L161
https://www.redmine.org/projects/redmine/repository/svn/entry/trunk/app/models/wiki.rb#L67
https://www.redmine.org/projects/redmine/repository/svn/entry/trunk/app/helpers/application_helper.rb#L497

#17 - 2010-10-19 17:17 - Albert Rosenfield

+1

#18 - 2010-11-03 15:24 - Axel B.

+1

#19 - 2010-11-11 14:32 - Jean-Philippe Lang
- Status changed from New to Closed

- Resolution set to Fixed
Restriction removed in r4391.

#20 - 2019-12-01 09:04 - Mischa The Evil
- Related to Patch #32522: Add Project.find_by name to target_project added
